import { ElementRef, EventEmitter, NgZone, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtCameraOptions, NgtCreatedState, NgtDpr, NgtGLOptions, NgtPerformance, NgtRaycaster, NgtSceneOptions, NgtSize } from './models';
import { NgtLoopService } from './services/loop.service';
import { NgtAnimationFrameStore } from './stores/animation-frame.store';
import { NgtCanvasInputsStore } from './stores/canvas-inputs.store';
import { EnhancedRxState } from './stores/enhanced-component-store';
import { NgtEventsStore } from './stores/events.store';
import { NgtPerformanceStore } from './stores/performance.store';
import { NgtStore } from './stores/store';
import * as i0 from "@angular/core";
export declare class NgtCanvas extends EnhancedRxState implements OnInit {
    private store;
    private canvasInputsStore;
    private performanceStore;
    private eventsStore;
    private animationFrameStore;
    private loopService;
    private ngZone;
    hostClass: boolean;
    set vr(vr: boolean | '');
    set linear(linear: boolean | '');
    set flat(flat: boolean | '');
    set frameloop(frameloop: 'always' | 'demand' | 'never');
    set orthographic(orthographic: boolean | '');
    set performance(performance: NgtPerformance);
    set size(size: NgtSize);
    set dpr(dpr: NgtDpr);
    set clock(clock: THREE.Clock);
    set raycaster(raycaster: Partial<NgtRaycaster>);
    set shadows(shadows: boolean | Partial<THREE.WebGLShadowMap>);
    set camera(cameraOptions: NgtCameraOptions);
    set scene(sceneOptions: NgtSceneOptions);
    set gl(glOptions: NgtGLOptions);
    created: EventEmitter<NgtCreatedState>;
    pointermissed: EventEmitter<MouseEvent>;
    set rendererCanvas(v: ElementRef<HTMLCanvasElement>);
    constructor(store: NgtStore, canvasInputsStore: NgtCanvasInputsStore, performanceStore: NgtPerformanceStore, eventsStore: NgtEventsStore, animationFrameStore: NgtAnimationFrameStore, loopService: NgtLoopService, ngZone: NgZone);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCanvas, [{ self: true; }, { self: true; }, { self: true; }, { self: true; }, { self: true; }, { self: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtCanvas, "ngt-canvas", never, { "vr": "vr"; "linear": "linear"; "flat": "flat"; "frameloop": "frameloop"; "orthographic": "orthographic"; "performance": "performance"; "size": "size"; "dpr": "dpr"; "clock": "clock"; "raycaster": "raycaster"; "shadows": "shadows"; "camera": "camera"; "scene": "scene"; "gl": "gl"; }, { "created": "created"; "pointermissed": "pointermissed"; }, never, never>;
}
