import { EventEmitter, NgZone, OnDestroy, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtObject3dController } from '../controllers/object-3d.controller';
import type { AnyConstructor } from '../models';
import * as i0 from "@angular/core";
export declare abstract class NgtGeometry<TGeometry extends THREE.BufferGeometry = THREE.BufferGeometry> implements OnInit, OnDestroy {
    #private;
    protected ngZone: NgZone;
    private parentObject;
    ready: EventEmitter<any>;
    constructor(ngZone: NgZone, parentObject: NgtObject3dController);
    abstract geometryType: AnyConstructor<TGeometry>;
    protected set geometryArgs(v: unknown | unknown[]);
    ngOnInit(): void;
    get geometry(): TGeometry;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtGeometry<any>, [null, { optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtGeometry<any>, never, never, {}, { "ready": "ready"; }, never>;
}
